atom/movable
	proc
		G_get_step(Dir)
			G_path_check()
			. = get_step(src,Dir)

		G_get_step_away(Trg,Max=5,Min=0,Limit=10)
			G_path_check()
			if(Trg) . = g_path.StepAway(Trg,Max,Min,Limit,1)

		G_get_step_rand()
			G_path_check()
			. = g_path.StepRand(,,,,1)

		G_get_step_to(Trg,Min=0,Limit=10)
			G_path_check()
			if(Trg) . = g_path.StepTo(Trg,Min,Limit,1)

		G_get_step_towards(Trg,Min=0)
			G_path_check()
			if(Trg) . = g_path.StepTowards(Trg,Min,1)

		G_get_stumble_step_to(Trg,Min=0,Prob=100)
			G_path_check()
			if(Trg) . = g_path.StepRand(Trg,Min,Prob,,1)

		G_get_stumble_step_away(Trg,Max=100,Prob=100)
			G_path_check()
			if(Trg) . = g_path.StepRand(Trg,Max,Prob,1,1)



		G_step(Dir)
			G_path_check()
			g_type = 0
			. = step(src,Dir)

		G_step_away(Trg,Max=5,Min=0,Limit=10)
			G_path_check()
			g_type = 0
			if(Trg) . = g_path.StepAway(Trg,Max,Min,Limit)

		G_step_rand()
			G_path_check()
			g_type = 0
			. = g_path.StepRand()

		G_step_to(Trg,Min=0,Limit=10)
			G_path_check()
			g_type = 0
			if(Trg) . = g_path.StepTo(Trg,Min,Limit)

		G_step_towards(Trg,Min=0)
			G_path_check()
			g_type = 0
			if(Trg) . = g_path.StepTowards(Trg,Min)

		G_stumble_step_to(Trg,Min=0,Prob=100)
			G_path_check()
			g_type = 0
			if(Trg) . = g_path.StepRand(Trg,Min,Prob)

		G_stumble_step_away(Trg,Max=100,Prob=100)
			G_path_check()
			g_type = 0
			if(Trg) . = g_path.StepRand(Trg,Max,Prob,1)



		G_walk(Dir,Lag=1)
			G_path_check()
			if(!Dir)
				g_type = 0
				g_target = null
				return
			if(Dir!=g_target||g_type!=1) spawn() for()
				sleep(max(1,g_lag+g_spd))
				if(Dir!=g_target||g_type!=1) return
				step(src,g_target)
			g_type = 1
			g_target = Dir
			g_lag = Lag

		G_walk_away(Trg,Max=5,Min=0,Lag=1,Limit=10)
			G_path_check()
			if(Trg&&(Trg!=g_target||g_type!=5)) spawn() for()
				sleep(max(1,g_lag+g_spd))
				if(!Trg||Trg!=g_target||g_type!=5) return
				g_path.StepAway(g_target,g_max,g_min,g_limit)
			g_type = 5
			g_target = Trg
			g_limit = Limit
			g_min = Min
			g_max = Max
			g_lag = Lag

		G_walk_rand(Lag=1)
			G_path_check()
			if(g_type!=3) spawn() for()
				sleep(max(1,g_lag+g_spd))
				if(g_type!=3) return
				g_path.StepRand()
			g_type = 3
			g_lag = Lag

		G_walk_to(Trg,Min=0,Lag=1,Limit=10)
			G_path_check()
			if(Trg&&(Trg!=g_target||g_type!=5)) spawn() for()
				sleep(max(1,g_lag+g_spd))
				if(!Trg||Trg!=g_target||g_type!=5) return
				g_path.StepTo(g_target,g_min,g_limit)
			g_type = 5
			g_target = Trg
			g_limit = Limit
			g_min = Min
			g_lag = Lag

		G_walk_towards(Trg,Min=0,Lag=1)
			G_path_check()
			if(Trg&&(Trg!=g_target||g_type!=6)) spawn() for()
				sleep(max(1,g_lag+g_spd))
				if(!Trg||Trg!=g_target||g_type!=6) return
				g_path.StepTowards(g_target,g_min)
			g_type = 6
			g_target = Trg
			g_min = Min
			g_lag = Lag

		G_stumble_walk_to(Trg,Min=0,Lag=1,Prob=100)
			G_path_check()
			if(Trg&&(Trg!=g_target||g_type!=4)) spawn() for()
				sleep(max(1,g_lag+g_spd))
				if(!Trg||Trg!=g_target||g_type!=4) return
				g_path.StepRand(g_target,g_min,g_limit)
			g_type = 4
			g_target = Trg
			g_limit = Prob
			g_min = Min
			g_lag = Lag

		G_stumble_walk_away(Trg,Max=100,Lag=1,Prob=100)
			G_path_check()
			if(Trg&&(Trg!=g_target||g_type!=4)) spawn() for()
				sleep(max(1,g_lag+g_spd))
				if(!Trg||Trg!=g_target||g_type!=4) return
				g_path.StepRand(g_target,g_max,g_limit,1)
			g_type = 4
			g_target = Trg
			g_limit = Prob
			g_max = Max
			g_lag = Lag

turf
	var/tmp
		access[]
		turf/dest
		PathNode/AI_pathnode
	proc
		can_access()
			if(!access)
				access = new /list()
				var/turf
					north = locate(x,y+1,z)
					east = locate(x+1,y,z)
					south = locate(x,y-1,z)
					west = locate(x-1,y,z)
					northeast = locate(x+1,y+1,z)
					southeast = locate(x+1,y-1,z)
					southwest = locate(x-1,y-1,z)
					northwest = locate(x-1,y+1,z)
				if(north) access += north
				if(west) access += west
				if(east) access += east
				if(south) access += south
				if(northwest) access += northwest
				if(northeast) access += northeast
				if(southwest) access += southwest
				if(southeast) access += southeast
			return access.Copy()
	warp/New()
		..()
		if(dest)
			var/turf/T = locate(dest)
			if(T) dest = T
			else dest = null
	Enter(atom/movable/M)
		if(dest) if(!M.multitile&&M.can_warp) M.G_warp(dest,src)
		else . = ..()

PathController
	var/tmp
		atom/movable/owner
		turf/dest_turf
		atom/dest
		list
			path
			open
			closed
			nodes
	New(O)
		owner = O
		return ..()
	proc
		StepTo(new_dest,min,limit,get_step) if(isturf(owner.loc))
			var/turf/old_dest = dest_turf
			dest = new_dest
			dest_turf = new_dest
			while(!isturf(dest_turf)) dest_turf = dest_turf.loc
			if(owner.loc == dest_turf) return
			if(length(path)&&(dest_turf != old_dest))
				var/in_path
				for(var/turf/T in path) if(T == dest_turf) {in_path = 1;break}
				if(!in_path) if(path[path.len] != old_dest)
					var/l[] = old_dest.can_access()
					for(var/turf/T in l) if(T == dest_turf)
						path.Cut(path.len)
						in_path = 1
						break
				if(!in_path)
					var
						turf/last = path[path.len]
						l[] = last.can_access()
					for(var/turf/T in l) if(T == dest_turf)
						path.Cut(path.len)
						in_path = 1
						break
				if(!in_path) path = null
			if(!length(path))
				Path(limit)
				if(length(path) < 2) return
				path.Cut(1,2)
			if((owner.z == dest.z)&&(G_get_dist(owner,dest) <= min)) if(!get_step)
				owner.dir = G_get_dir(owner,dest)
				owner.G_adjust_icon()
			else if(get_step)
				var/turf/T
				while(!T&&path.len)
					T = get_step_towards(owner,path[1])
					if(owner.Can_Enter(T)) . = T
					else T = null
					path.Cut(1,2)
			else
				var/turf/T
				while(!T&&path.len)
					T = get_step_towards(owner,path[1])
					if(owner.Can_Enter(T)) step_towards(owner,T)
					else T = null
					path.Cut(1,2)
				if(T)
					. = 1
				else
					path = null
					return StepRand(dest,,100)

		StepAway(new_dest,max,min,limit,get_step) if(isturf(owner.loc))
			var/turf/old_dest = dest_turf
			dest = new_dest
			dest_turf = new_dest
			while(!isturf(dest_turf)) dest_turf = dest_turf.loc
			if(length(path)&&(dest_turf != old_dest)) for(var/turf/T in path)
				if(G_get_dist(owner,dest,T.x-owner.x,T.y-owner.y) < min) {path = null; break}
			if(!length(path))
				Path(limit,max,min)
				if(length(path) < 2) return
				path.Cut(1,2)
			if(G_get_dist(owner,dest) >= max) if(!get_step)
				owner.dir = G_get_dir(dest,owner)
				owner.G_adjust_icon()
			else if(get_step)
				var/turf/T
				while(!T&&path.len)
					T = get_step_towards(owner,path[1])
					if(owner.Can_Enter(T)) . = T
					else T = null
					path.Cut(1,2)
			else
				var/turf/T
				while(!T&&path.len)
					T = get_step_towards(owner,path[1])
					if(owner.Can_Enter(T)) step_towards(owner,T)
					else T = null
					path.Cut(1,2)
				if(T)
					. = 1
				else
					path = null
					return StepRand(dest,,100,1)

		StepTowards(new_dest,min,get_step) if(isturf(owner.loc))
			dest = new_dest
			dest_turf = new_dest
			while(!isturf(dest_turf)) dest_turf = dest_turf.loc
			if(owner.loc == dest_turf) return
			var
				can_access[] = owner.loc:can_access()
				turf/T = owner.loc
				T_dest = G_get_true_dist(owner,dest)
			for(var/i = 1 to can_access.len)
				var
					turf/T2 = can_access[i]
					T2_dest
				if(owner.Possible_Path(T2))
					T2_dest = G_get_true_dist(owner,dest,T2.x-owner.x,T2.y-owner.y)
					if(T2_dest < T_dest) {T = T2; T_dest = T2_dest}
			if(!T)
			else if(G_get_dist(owner,dest) <= min) if(!get_step)
				owner.dir = G_get_dir(owner,dest)
				owner.G_adjust_icon()
			else if(get_step)
				. = get_step_towards(owner,T)
			else if(step_towards(owner,T))
				. = 1

		StepRand(new_dest,limit,stumble_prob,away,get_step) if(isturf(owner.loc))
			var
				can_access[] = owner.loc:can_access()
				l[] = list()
			if(new_dest)
				var/current = G_get_dist(owner,new_dest)
				if(away)
					if(current >= limit) return
					for(var/i = 1 to can_access.len)
						var/turf/T = can_access[i]
						if(owner.Can_Enter(T,1))
							if(G_get_dist(owner,new_dest,T.x-owner.x,T.y-owner.y) >= current)
								l += T
				else
					if(current <= limit) return
					for(var/i = 1 to can_access.len)
						var/turf/T = can_access[i]
						if(owner.Can_Enter(T,1))
							if(G_get_dist(owner,new_dest,T.x-owner.x,T.y-owner.y) <= current)
								l += T
				if(!prob(stumble_prob)) l = list()
			if(!l.len) for(var/i = 1 to can_access.len)
				var/turf/T = can_access[i]
				if(owner.Can_Enter(T,1)) l += T
			if(!l.len) if(new_dest)
				if(away) owner.dir = G_get_dir(new_dest,owner)
				else owner.dir = G_get_dir(owner,new_dest)
				owner.G_adjust_icon()
			else if(get_step)
				. = get_step_towards(owner,pick(l))
			else if(step_towards(owner,pick(l)))
				if(new_dest)
					if(away) owner.dir = G_get_dir(new_dest,owner)
					else owner.dir = G_get_dir(owner,new_dest)
					owner.G_adjust_icon()
				. = 1

		Path(limit,max,min)
			open = list(owner.loc)
			closed = list()
			if(max) path = Sequence(SearchAway(limit,max,min))
			else path = Sequence(SearchTo(limit))
			for(var/N in nodes) N:Clear()
			for(var/turf/T in closed) T.AI_pathnode.Clear()
			for(var/turf/T in open) if(T.AI_pathnode) T.AI_pathnode.Clear()
			nodes = null
			open = null
			closed = null

		SearchTo(limit)
			var
				PathNode
					P = new(owner.loc,,owner,0,G_get_true_dist(owner,dest))
					Best = P
				turf/tdest
			nodes = list(P)
			if(!owner.can_warp)
				tdest = dest
			else if(get_step_to(owner,dest))
				tdest = dest
			else if(owner.multitile) for(var/atom/movable/M in owner.components) if(get_step_to(M,dest))
				tdest = dest
				break
			if(!tdest)
				var
					list
						l = list()
						l2 = list()
						l3 = list()
						l4 = list()
					mob/G_Step_Test/S = new
				S.density = owner.density
				for(var/turf/warp/W in range(10,owner)) if(W.dest) if(W.dest.dest == W)
					if(get_step_to(owner,W))
						l += W
					else if(owner.multitile) for(var/atom/movable/M in owner.components)
						if(get_step_to(M,W))
							l += W
							break
				for(var/turf/warp/W in range(10,dest)) if(W.dest) if(W.dest.dest == W)
					S.loc = dest
					if(get_step_to(S,W))
						if(W.dest in l)
							tdest = W.dest
							goto Search
						else
							l2 += W.dest
							l3 += W
							l4 += W
				while(l2.len)
					var/turf/warp/W = l2[1]
					for(var/turf/warp/W2 in range(10,W)-l2-l3) if(W2.dest) if(W2.dest.dest == W2)
						S.loc = W
						if(get_step_to(S,W2))
							if(W2.dest in l)
								tdest = W2.dest
								goto Search
							else
								l2 += W2.dest
								l3 += W2
					l2.Cut(1,2)
					l3 += W
				for(var/turf/warp/W in l4)
					if(W.dest.z == owner.z)
						tdest = W.dest
						goto Search
					for(var/turf/warp/W2 in l) if(W.dest.z == W2.dest.z)
						tdest = W2
						goto Search
				if(owner.z == dest.z)
					tdest = dest
					goto Search
				for(var/turf/warp/W in l) if(W.dest.z == dest.z)
					tdest = W
					goto Search
				Search
				S.loc = null
			if(tdest) while(nodes.len)
				P = nodes[1]
				var/turf/T = P.turf
				if(!G_get_dist(owner,tdest,T.x-owner.x,T.y-owner.y))
					if(owner.Can_Enter(T)) return P
					else return Best
				if(closed.Find(T))
					nodes.Cut(1,2)
					continue
				if(owner.multitile) if(!owner.Can_Enter(T))
					nodes.Cut(1,2)
					continue
				if(G_get_dist(owner,tdest,T.x-owner.x,T.y-owner.y) < G_get_dist(owner,tdest,Best.turf.x-owner.x,Best.turf.y-owner.y))
					if(owner.Can_Enter(T)) Best = P
				if(nodes.len > AI_PATHNODE_LIMIT) return Best
				if(limit && P.cost >= limit) return Best
				nodes.Cut(1,2)
				closed += T
				open -= T
				var
					can_access[] = T.can_access()
					new_cost = P.cost + 1
				for(var/i = 1 to can_access.len)
					var/turf/T2 = can_access[i]
					if(!owner.Possible_Path(T2,tdest)) continue
					var/PathNode/P2 = T2.AI_pathnode
					if(P2)
						if(new_cost >= P2.cost) continue
						if(closed.Find(T2))
							open += T2
							closed -= T2
						else
							nodes -= P2
						P2.cost = new_cost
						P2.parent = P
					else
						var/dist = G_get_true_dist(owner,tdest,T2.x-owner.x,T2.y-owner.y)
						P2 = new /PathNode(T2,P,owner,new_cost,dist)
						open += T2
					if(!G_get_dist(owner,tdest,T2.x-owner.x,T2.y-owner.y)) return P2
					Sort(P2)
			return Best

		SearchAway(limit,max,min)
			var
				PathNode
					P = new(owner.loc,,owner,0,G_get_true_dist(owner,dest))
					Best = P
				current_min = G_get_dist(owner,dest,Best.turf.x-owner.x,Best.turf.y-owner.y)
			nodes = list(P)
			while(nodes.len)
				P = nodes[1]
				var/turf/T = P.turf
				if(G_get_dist(owner,dest,T.x-owner.x,T.y-owner.y) >= max)
					if(owner.Can_Enter(T)) return P
				if(closed.Find(T))
					nodes.Cut(1,2)
					continue
				if(owner.multitile) if(!owner.Can_Enter(T))
					nodes.Cut(1,2)
					continue
				switch(G_get_dist(owner,dest,T.x-owner.x,T.y-owner.y) - G_get_dist(owner,dest,Best.turf.x-owner.x,Best.turf.y-owner.y))
					if(1)
						if(owner.Can_Enter(T)) Best = P
					if(0) if(G_get_true_dist(owner,dest,T.x-owner.x,T.y-owner.y) > G_get_true_dist(owner,dest,Best.turf.x-owner.x,Best.turf.y-owner.y))
						if(owner.Can_Enter(T)) Best = P
				if(nodes.len > AI_PATHNODE_LIMIT) return Best
				if(limit && P.cost >= limit) return Best
				nodes.Cut(1,2)
				closed += T
				open -= T
				var
					can_access[] = T.can_access()
					new_cost = P.cost + 1
				for(var/i = 1 to can_access.len)
					var
						turf/T2 = can_access[i]
						T2_dist = G_get_dist(owner,dest,T2.x-owner.x,T2.y-owner.y)
					if(!owner.Can_Enter(T2)) continue
					if(T2_dist < min)
						if(T2_dist < current_min) continue
						current_min = T2_dist
					var/PathNode/P2 = T2.AI_pathnode
					if(P2)
						if(new_cost >= P2.cost) continue
						if(closed.Find(T2))
							open += T2
							closed -= T2
						else
							nodes -= P2
						P2.cost = new_cost
						P2.parent = P
					else
						var/dist = G_get_true_dist(owner,dest,T2.x-owner.x,T2.y-owner.y)
						P2 = new /PathNode(T2,P,owner,new_cost,-2*dist)
						open += T2
					Sort(P2)
			return Best

		Sort(PathNode/P)
			var
				high = nodes.len
				low = 1
			P.total = P.Total(owner)
			while(low <= high)
				var
					mid = (low+high)/2
					i = round(mid)
				if(mid != i) i++
				var/PathNode/P2 = nodes[i]
				if(P.total <= P2.total)
					high = i - 1
				else
					low = i + 1
			nodes.Insert(low,P)

		Sequence(PathNode/P)
			if(P)
				var/l[] = Sequence(P.parent)
				l += P.turf
				return l
			else . = list()

proc
	G_get_dir(atom/movable/A,atom/movable/B) . = G_get(A,B,1)
	G_get_dist(atom/movable/A,atom/movable/B,x_off,y_off) . = G_get(A,B,2,x_off,y_off)
	G_get_true_dist(atom/movable/A,atom/movable/B,x_off,y_off) . = G_get(A,B,3,x_off,y_off)

	G_get(atom/movable/A,atom/movable/B,function,x_off,y_off) if(isloc(A)&&isloc(B)&&!isarea(A)&&!isarea(B))
		var/list
			la;lb
		if(!isturf(A))
			while(!isturf(A.loc)) A = A.loc
			if(A.multitile)
				la = list()
				for(var/atom/C in A.components) la += C.loc
			else A = A.loc
		if(!isturf(B))
			while(!isturf(B.loc)) B = B.loc
			if(B.multitile)
				lb = list()
				for(var/atom/C in B.components) lb += C.loc
			else B = B.loc
		switch(function)
			if(1)
				if(la&&lb) for(var/atom/a in la) for(var/atom/b in lb)
					. = get_dir(a,b)
					if(. in list(NORTH,EAST,SOUTH,WEST)) return
				else if(la) for(var/atom/a in la)
					. = get_dir(a,B)
					if(. in list(NORTH,EAST,SOUTH,WEST)) return
				else if(lb) for(var/atom/b in lb)
					. = get_dir(A,b)
					if(. in list(NORTH,EAST,SOUTH,WEST)) return
				else
					. = get_dir(A,B)
			if(2)
				. = 1000
				if(la&&lb) for(var/atom/a in la) for(var/atom/b in lb)
					. = min(.,max(abs(a.x+x_off-b.x),abs(a.y+y_off-b.y)))
				else if(la) for(var/atom/a in la)
					. = min(.,max(abs(a.x+x_off-B.x),abs(a.y+y_off-B.y)))
				else if(lb) for(var/atom/b in lb)
					. = min(.,max(abs(A.x+x_off-b.x),abs(A.y+y_off-b.y)))
				else
					. = min(.,max(abs(A.x+x_off-B.x),abs(A.y+y_off-B.y)))
			else
				. = 1000
				if(la&&lb) for(var/atom/a in la) for(var/atom/b in lb)
					. = min(.,sqrt((a.x+x_off-b.x)**2+(a.y+y_off-b.y)**2))
				else if(la) for(var/atom/a in la)
					. = min(.,sqrt((a.x+x_off-B.x)**2+(a.y+y_off-B.y)**2))
				else if(lb) for(var/atom/b in lb)
					. = min(.,sqrt((A.x+x_off-b.x)**2+(A.y+y_off-b.y)**2))
				else
					. = min(.,sqrt((A.x+x_off-B.x)**2+(A.y+y_off-B.y)**2))

	G_get_closest(atom/movable/A,atom/movable/B,dist)
		var/list
			d = 1000
			la = list()
			lb = list()
		if(A.multitile) for(var/atom/C in A.components) la += C
		else la += A
		if(B.multitile) for(var/atom/C in B.components) lb += C
		else lb += B
		for(var/atom/a in la) for(var/atom/b in lb) if(b in view(dist,a))
			var/t = sqrt((a.x-b.x)**2+(a.y-b.y)**2)
			if(t < d)
				d = t
				. = b

PathNode
	var
		cost
		dist
		total
		turf/turf
		PathNode/parent
	New(T,p,o,c,d)
		turf = T
		turf.AI_pathnode = src
		total = Total(o)
		parent = p
		cost = c
		dist = d
		return ..()
	proc
		Total(atom/movable/owner)
			. = cost + 1.5*dist
			if(owner.density) for(var/atom/movable/M in turf.contents)
				if(M.density) return . + 10
		Clear()
			parent = null
			turf.AI_pathnode = null
			turf = null

mob/G_Step_Test/New()
atom/movable
	var/tmp
		PathController/g_path
		atom/movable/brain
		list/components
		atom/g_target
		g_position
		multitile
		can_warp
		g_limit
		g_type
		g_min
		g_max
		g_lag
		g_spd
	Move(turf/T,d)
		if(multitile)
			if(Can_Enter(T))
				for(var/atom/movable/C in components)
					var/turf/T2 = locate(T.x+C.x-x,T.y+C.y-y,T.z)
					if(T2.dest) return G_warp(T2.dest,T2)
				var/t = density
				density = 0
				. = ..()
				density = t
				if(.) for(var/atom/movable/C in components)
					C.loc = get_step(C,d)
			G_adjust_icon()
		else
			. = ..()
			G_adjust_icon()
	proc
		G_path_check() if(!g_path) g_path = new(src)

		Possible_Path(turf/T,turf/W)
			if(multitile) for(var/atom/movable/C in components)
				var/turf/T2 = locate(T.x+C.x-x,T.y+C.y-y,T.z)
				if(!T2) return
				if(density&&T2.density) return
				if(T2.dest) if(!can_warp||(W&&T2!=W)) return
			else
				if(density&&T.density) return
				if(T.dest) if(!can_warp||(W&&T!=W)) return
			. = 1

		Can_Enter(turf/T,no_warp)
			if(multitile) for(var/atom/movable/C in components)
				var/turf/T2 = locate(T.x+C.x-x,T.y+C.y-y,T.z)
				if(!T2) return
				if(density)
					if(T2.density) return
					for(var/atom/movable/M in T2.contents - src - components)
						if(M.density) return
				if(T2.dest&&(no_warp||!can_warp)) return
			else
				if(density)
					if(T.density) return
					for(var/atom/movable/M in T.contents)
						if(M.density) return
				if(T.dest&&(no_warp||!can_warp)) return
			. = 1

		G_multitile(c_type) if(multitile)
			components = list()
			var/xl[],yl[]
			switch(multitile)
				if(FOUR_SQUARE)
					xl = list(0,1,0,1)
					yl = list(0,0,1,1)
				if(TWO_TALL)
					xl = list(0,0)
					yl = list(0,1)
				if(TWO_WIDE)
					xl = list(0,1)
					yl = list(0,0)
			for(var/v = 1 to xl.len)
				var/atom/movable/C = new c_type(locate(x+xl[v],y+yl[v],z))
				C.brain = src
				components += C
				C.density = density
				C.icon = icon
				C.g_position = "[xl[v]],[yl[v]]"
				C.animate_movement = 3
			G_adjust_icon()

		G_adjust_icon()
			if(multitile) for(var/atom/movable/C in components)
				if(icon_state) C.icon_state = "[icon_state] [C.g_position]"
				else C.icon_state = C.g_position
				C.dir = dir

		G_warp(turf/T,turf/Old)
			if(brain) return brain.G_warp(T,Old)
			if(g_target == Old) G_walk(0)
			if(multitile)
				for(var/turf/T2 in range(3,T)) if(G_get_dist(src,T,T2.x-x,T2.y-y) == 1) if(Can_Enter(T2))
					for(var/atom/movable/C in components)
						C.loc = locate(T2.x+C.x-x,T2.y+C.y-y,T2.z)
					loc = T2
					dir = G_get_dir(T,src)
					G_adjust_icon()
					return
			else
				if(g_target == Old) G_walk(0)
				loc = T
				var/turf/T2 = get_step(src,dir)
				if(T2) if(Can_Enter(T2))
					step_to(src,T2)
					return
				G_path_check()
				g_path.StepRand()